package com.sun.corba.se.impl.ior;

import org.omg.CORBA_2_3.portable.OutputStream;
import java.util.Iterator;
import com.sun.corba.se.spi.ior.ObjectAdapterId;

abstract class ObjectAdapterIdBase implements ObjectAdapterId
{
    ObjectAdapterIdBase() {
    }
    
    @Override
    public boolean equals(Object o) {
        if (!(o instanceof ObjectAdapterId)) {
            return false;
        }
        ObjectAdapterId objectAdapterId = (ObjectAdapterId)o;
        Iterator<Object> iterator = this.iterator();
        Iterator<Object> iterator2 = objectAdapterId.iterator();
        while (iterator.hasNext() && iterator2.hasNext()) {
            if (!((String)(String)iterator.next()).equals((String)(String)iterator2.next())) {
                return false;
            }
            continue;
        }
        return iterator.hasNext() == iterator2.hasNext();
    }
    
    @Override
    public int hashCode() {
        int n = 17;
        Iterator<Object> iterator = this.iterator();
        while (iterator.hasNext()) {
            n = 37 * n + ((String)(String)iterator.next()).hashCode();
        }
        return n;
    }
    
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("ObjectAdapterID[");
        Iterator<Object> iterator = this.iterator();
        int n = 1;
        while (iterator.hasNext()) {
            String str = (String)(String)iterator.next();
            if (n != 0) {
                n = 0;
            }
            else {
                sb.append("/");
            }
            sb.append(str);
        }
        sb.append("]");
        return sb.toString();
    }
    
    public void write(OutputStream outputStream) {
        outputStream.write_long(this.getNumLevels());
        Iterator<Object> iterator = this.iterator();
        while (iterator.hasNext()) {
            outputStream.write_string((String)(String)iterator.next());
        }
    }
}
